﻿init python:
    import pygame
    import math
    import random
    import time
    random.seed(time.perf_counter_ns())
    def distance(x, y):
        if x >= y:
            result = x - y
        else:
            result = y - x
        return result
    class shoomup_enemy(renpy.Displayable):
        def __init__(self, image, x, y, parent, bullet = None):
            super(renpy.Displayable,self).__init__()
            self.image = image
            self.x = x
            self.y = y
            self.parent = parent
            self.bullet = bullet
            self.x_velocity = 0
            self.y_velocity = 1

            self.rotation = 0

            self.movement_pattern = 1
            self.movement_timer = 0
            self.cool_down = 0
        def shoot(self):
            if not self.cool_down:
                bullet = shoomup_enemy_bullet(self.bullet, self.x, self.y, self.parent)
                bullet.y_velocity = 4
                self.parent.enemy_bullets.append(bullet)
                self.cool_down = 200
                renpy.restart_interaction()
        def movement_check(self):
            if  self.movement_pattern in [1, 8]:
                pass
            elif  self.movement_pattern == 2:
                if self.x_velocity == 0:
                    self.x_velocity = random.choice([-2,2])
                elif abs(self.x) > 140:
                    self.x_velocity = -self.x_velocity
            elif self.movement_pattern == 3:
                self.rotation += -10
            elif self.movement_pattern == 4:
                if self.y > -50:
                    if self.x_velocity == 0:
                        self.x_velocity = random.choice([-2,2])
                        self.y_velocity = 0
                    elif abs(self.x) > 140:
                        self.x_velocity = -self.x_velocity
                    if distance(self.x, self.parent.fighter.x) < 8:
                        self.y_velocity = 3
                        self.x_velocity = 0
                        self.movement_pattern = 1
            elif self.movement_pattern == 7:
                if self.x_velocity == 0:
                    self.x_velocity = random.choice([-1,1])
                    self.y_velocity = 0
                elif abs(self.x) > 140:
                    self.x_velocity = -self.x_velocity
                if distance(self.x, self.parent.fighter.x) < 8:
                    self.shoot()
            else:
                pass
        def render(self,width,height,st,at):
            if self.cool_down > 0:
                self.cool_down -= 1
                if self.cool_down < 0:
                    self.cool_down = 0
            
            self.x += self.x_velocity
            self.y += self.y_velocity

            if -70 < self.y:
                self.movement_check()
            if self.y > 100:
                try:
                    self.parent.enemies.remove(self)
                except:
                    self.parent.tries += 1
                    renpy.restart_interaction()

            t = Transform(self.image, xanchor=0.5, yanchor=0.5, rotate=self.rotation)
            child_render = renpy.render(t, width, height, st, at)
            cw, ch = child_render.get_size()

            rv = renpy.Render(cw, ch)
            rv.blit(child_render, (self.x,self.y))

            renpy.redraw(self, 0)
            return rv
    class shoomup_enemy_bullet(renpy.Displayable):
        def __init__(self, image, x, y, parent):
            super(renpy.Displayable,self).__init__()
            self.image = image
            self.x = x
            self.y = y
            self.parent = parent
            self.x_velocity = 0
            self.y_velocity = 0

        def render(self,width,height,st,at):
            self.x += self.x_velocity
            self.y += self.y_velocity
            if self.y > 76:
                try:
                    self.parent.enemy_bullets.remove(self)
                except:
                    self.parent.tries += 1

            if distance(self.y, self.parent.fighter.y) < 8:
                if distance(self.x, self.parent.fighter.x) < 16:
                    try:
                        self.parent.enemy_bullets.remove(self)
                        self.parent.fighter.got_shot()
                        renpy.restart_interaction()
                    except:
                        self.parent.tries += 1
            t = Transform(self.image, xanchor=0.5, yanchor=0.5,)
            child_render = renpy.render(t, width, height, st, at)
            cw, ch = child_render.get_size()

            rv = renpy.Render(cw, ch)
            rv.blit(child_render, (self.x,self.y))

            renpy.redraw(self, 0)
            return rv
    class shoomup_player_bullet(renpy.Displayable):
        def __init__(self, image, x, y, parent):
            super(renpy.Displayable,self).__init__()
            self.image = image
            self.x = x
            self.y = y
            self.parent = parent
            self.x_velocity = 0
            self.y_velocity = 0

        def render(self,width,height,st,at):
            self.x += self.x_velocity
            self.y += self.y_velocity
            for i in self.parent.enemies:
                if distance(self.y, i.y) < 16:
                    if distance(self.x, i.x) < 16:
                        try:
                            self.parent.player_bullets.remove(self)
                            self.parent.enemies.remove(i)
                            renpy.restart_interaction()
                        except:
                            self.parent.tries += 1

            if self.y < -84:
                try:
                    self.parent.player_bullets.remove(self)
                except:
                    self.parent.tries += 1

            t = Transform(self.image, xanchor=0.5, yanchor=0.5,)
            child_render = renpy.render(t, width, height, st, at)
            cw, ch = child_render.get_size()

            rv = renpy.Render(cw, ch)
            rv.blit(child_render, (self.x,self.y))

            renpy.redraw(self, 0)
            return rv

    class shoomup_fighter(renpy.Displayable):
        def __init__(self, name, image, bullet):
            super(renpy.Displayable,self).__init__()
            self.name = name
            self.image = image
            self.bullet = bullet
            self.parent = None

            self.x = 0
            self.y = 0

            self.w = 0
            self.a = 0
            self.s = 0
            self.d = 0

            self.speed = 2
            self.alive = True
        def shoot(self):
            bullet = shoomup_player_bullet(self.bullet, self.x, self.y, self.parent)
            bullet.y_velocity = -10
            self.parent.player_bullets.append(bullet)
        def got_shot(self):
            self.alive = False

        def render(self,width,height,st,at):
            if self.alive:
                self.x += (self.a + self.d)*self.speed
                self.y += (self.w + self.s)*self.speed
                if self.y > 76:
                    self.y = 76
                elif self.y < -84:
                    self.y = -84
                if self.x > 145:
                    self.x = 145
                elif self.x < -145:
                    self.x = -145
                for i in self.parent.enemies:
                    if distance(self.y, i.y) < 16:
                        if distance(self.x, i.x) < 16:
                            try:
                                self.parent.enemies.remove(i)
                                self.got_shot()
                                renpy.restart_interaction()
                            except:
                                self.parent.tries += 1
            t = Transform(self.image, xanchor=0.5, yanchor=0.5,)
            child_render = renpy.render(t, width, height, st, at)
            cw, ch = child_render.get_size()

            rv = renpy.Render(cw, ch)
            rv.blit(child_render, (self.x,self.y))

            # if self.a or self.d or self.w or self.s:
            if self.alive:
                renpy.redraw(self, 0)
            return rv

        def event(self, ev, x, y, st):
            if ev.type == pygame.KEYDOWN:
                if ev.key == pygame.K_a:
                    self.a = -1
                    renpy.redraw(self, 0)
                    raise renpy.IgnoreEvent()
                elif ev.key == pygame.K_d:
                    self.d = 1
                    renpy.redraw(self, 0)
                    raise renpy.IgnoreEvent()
                if ev.key == pygame.K_w:
                    self.w = -1
                    renpy.redraw(self, 0)
                    raise renpy.IgnoreEvent()
                elif ev.key == pygame.K_s:
                    self.s = 1
                    renpy.redraw(self, 0)
                    raise renpy.IgnoreEvent()

            elif ev.type == pygame.KEYUP:
                if ev.key == pygame.K_a:
                    self.a = 0
                elif ev.key == pygame.K_d:
                    self.d = 0
                if ev.key == pygame.K_w:
                    self.w = 0
                elif ev.key == pygame.K_s:
                    self.s = 0
            return None

    class shoomup_level:
        def __init__(self, name, fighter, enemy_list):
            self.name = name
            fighter.parent = self
            self.fighter = fighter
            self.enemy_list = enemy_list
            self.enemies = []
            self.enemy_bullets = []
            self.player_bullets = []
            self.tries = 0
        def spawn(self):
            if len(self.enemies) < 5:
                e = random.choice(self.enemy_list)
                enemy = shoomup_enemy(e[0], random.randint(-140, 140), -100, self, e[2])
                enemy.movement_pattern = e[1]
                if e[1] == 8:
                    enemy.y_velocity = 3
                self.enemies.append(enemy)
        def restart(self):
            self.fighter.alive = True
            self.enemies = []
            self.enemy_bullets = []
            self.player_bullets = []
            self.tries = 0

screen shoomup(g):
    modal True
    fixed:
        xysize 320,180 align .5,.5
        at zoom(6, True)
        for i in g.enemies:
            add i align .5,.5
        for i in g.enemy_bullets:
            add i align .5,.5
        for i in g.player_bullets:
            add i align .5,.5
        add g.fighter align .5,.5
    if g.fighter.alive:
        timer 1 repeat True action Function(g.spawn)
        key "K_SPACE" action Function(g.fighter.shoot)
    else:
        button:
            align .5,.5 padding 20,20 background "#fff9"
            text "Re-try"
            action Function(g.restart)
    vbox:
        # text str(g.fighter.y)
        # text str(g.fighter.x)
        text f"player bullets: {len(g.player_bullets)}"
        text f"Enemy bullets: {len(g.enemy_bullets)}"
        text f"enemies: {len(g.enemies)}"
        text str(g.tries)

image shoomup_enemy_1 = Crop((32,0,32,32), "shoomup/shoomup_sprites.png")
image shoomup_enemy_2 = Crop((32,32,32,32), "shoomup/shoomup_sprites.png")
image shoomup_enemy_3 = Crop((32,64,32,32), "shoomup/shoomup_sprites.png")
image shoomup_enemy_4 = Crop((32,96,32,32), "shoomup/shoomup_sprites.png")

image shoomup_enemy_5 = Crop((64,0,32,32), "shoomup/shoomup_sprites.png")
image shoomup_enemy_6 = Crop((64,32,32,32), "shoomup/shoomup_sprites.png")
image shoomup_enemy_7 = Crop((64,64,32,32), "shoomup/shoomup_sprites.png")
image shoomup_enemy_8 = Crop((64,96,16,32), "shoomup/shoomup_sprites.png")

image shoomup_enemy_7_bullet = Crop((81,113,5,5), "shoomup/shoomup_sprites.png")

image crimson_pterodactyl = Crop((0,0,32,32), "shoomup/shoomup_sprites.png")
image crimson_laser = Crop((0,64,4,11), "shoomup/shoomup_sprites.png")
default crimson_pterodactyl = shoomup_fighter(
    "Crimson Pterodactyl",
    "crimson_pterodactyl",
    "crimson_laser",
)
default shoomup_level_1 = shoomup_level(
    name = "Moon",
    fighter = crimson_pterodactyl,
    enemy_list = [
        ["shoomup_enemy_1", 1, None],
        ["shoomup_enemy_2", 2, None],
        ["shoomup_enemy_3", 3, None],
        ["shoomup_enemy_4", 4, None],
        ["shoomup_enemy_5", 5, None],
        ["shoomup_enemy_6", 6, None],
        ["shoomup_enemy_7", 7, "shoomup_enemy_7_bullet"],
        ["shoomup_enemy_8", 8, None],
    ],
    )

label shoomup_example:
    call screen shoomup(shoomup_level_1)




